Package: dupRadar
Type: Package
Title: Assessment of duplication rates in RNA-Seq datasets
Version: 1.43.0
Date: 2015-09-26
Author: Sergi Sayols <sergisayolspuig@gmail.com>, Holger Klein
        <holger.klein@gmail.com>
Maintainer: Sergi Sayols <sergisayolspuig@gmail.com>, Holger Klein
 <holger.klein@gmail.com>
Description: Duplication rate quality control for RNA-Seq datasets.
URL: https://www.bioconductor.org/packages/dupRadar,
        https://ssayols.github.io/dupRadar/index.html
VignetteBuilder: knitr
Suggests: BiocStyle, knitr, rmarkdown, AnnotationHub
Depends: R (>= 3.2.0)
Imports: Rsubread (>= 1.14.1), KernSmooth
LazyData: true
License: GPL-3
biocViews: Technology, Sequencing, RNASeq, QualityControl,
        ImmunoOncology
NeedsCompilation: no
Encoding: UTF-8
RoxygenNote: 7.3.2
Config/Bioconductor/UnsupportedPlatforms: windows
git_url: https://git.bioconductor.org/packages/dupRadar
git_branch: devel
git_last_commit: 26451be
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
Packaged: 2026-04-28 22:26:14 UTC; biocbuild

[![](https://img.shields.io/badge/Altmetric-9-blue.svg)](https://www.altmetric.com/details/12855878)

# dupRadar

Assessment of duplication rates in RNA-Seq datasets.

## Introduction to dupRadar

PCR clonal artefacts originating from NGS library preparation can affect both 
genomic as well as RNA-Seq applications when protocols are pushed to their 
limits. In RNA-Seq however the artifactual reads are not easy to tell apart 
from normal read duplication due to natural over-sequencing of highly expressed 
genes. Especially when working with little input material or single cells 
assessing the fraction of duplicate reads is an important quality control step 
for NGS data sets. Up to now there are only tools to calculate the global 
duplication rates that do not take into account the effect of gene expression 
levels which leaves them of limited use for RNA-Seq data.

## Installation

To install this package, start R and enter:

```r
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("dupRadar")
```

## Documentation

To view documentation for the version of this package installed in your system, start R and enter:

```r
browseVignettes("dupRadar")
```

or access the [pkgdown documentation](https://ssayols.github.io/dupRadar/index.html).

## Dependencies

### Imports (mandatory for core functionality)

* [Rsubread](http://bioconductor.org/packages/Rsubread/): Mapping, quantification and variant analysis of sequencing data.

## Citation

Sayols S, Scherzinger D, Klein H (2016). "dupRadar: a Bioconductor package for the assessment of PCR artifacts in RNA-Seq data." BMC Bioinformatics, 17, 428. [doi: 10.1186/s12859-016-1276-2](http://dx.doi.org/10.1186/s12859-016-1276-2).

#' Duplication rate ~ total reads per kilobase (RPK) boxplot
#'
#' \code{duprateExpBoxplot} Duplication rate ~ total reads per kilobase (RPK) boxplot
#'
#' This function makes a boxplot showing the distribution of per gene duplication rate versus
#' the reads per kilobase (RPK) inside gene expression bins.
#
#' @param DupMat The duplication matrix calculated by \code{analyzeDuprates}
#' @param stepSize Expression bin seze for the boxplot
#' @param ... Other params sent to boxplot
#' @return nothing
#' @examples
#' # dm is a duplication matrix calculated by analyzeDuprates:
#' # R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
#' attach(dupRadar_examples)
#'
#' # duprate boxplot
#' duprateExpBoxplot(DupMat=dm)
#' @export
duprateExpBoxplot <- function(DupMat, stepSize=0.05, ...) {
  
    ## define expression bins for boxplot
    binVec <- seq(stepSize, 1, stepSize)
  
    ## get mean duplication rate per bin
    ## for axis annotation

    binMeanExpression <- sapply(binVec, getBinRpkMean, stepSize, DupMat)


    ## get list with duplication rate vectors per bin
    ## for boxplot
    binDupDistribution <- sapply(binVec, getBinDuplication, stepSize, DupMat)
  
    names(binDupDistribution) <- paste0(as.character(100 * (binVec - stepSize)),
                                        " - ",as.character(100 * binVec)," %",
                                        " / ", binMeanExpression)
 
    opar <- par(mar=c(6,4,4,2))
    boxplot(binDupDistribution,
            ylim=c(0,1),
            las=3,
            ylab="duplication (%)",
            axes=FALSE,
            ...)
    axis(2)
    axis(1,,las=2,cex.axis=.6,
         labels=names(binDupDistribution),
         at=1:length(names(binDupDistribution)))
    title(xlab="mean expression (reads/kbp)", line=5)

    par(opar)
}

## ----pre,echo=FALSE,results='hide'--------------------------------------------
library(knitr)
opts_chunk$set(warning=FALSE,message=FALSE,cache=TRUE)

## ----style,echo=FALSE,results='asis'------------------------------------------
BiocStyle::markdown()

## ----loadLibrary--------------------------------------------------------------
library(dupRadar)

## ----eval=FALSE---------------------------------------------------------------
#  # call the duplicate marker and analyze the reads
#  bamDuprm <- markDuplicates(dupremover="bamutil",
#  			   bam="test.bam",
#  	    	   path="/opt/bamUtil-master/bin",
#  			   rminput=FALSE)

## -----------------------------------------------------------------------------
if(suppressWarnings(require(AnnotationHub))) {
    ah = AnnotationHub()
    query(ah, c("ensembl", "80", "Takifugu", "gtf"))    # discovery
    cache(ah["AH47101"])                                # retrieve / file path
}

## -----------------------------------------------------------------------------
attach(dupRadar_examples)

## ----eval=FALSE---------------------------------------------------------------
#  # The call parameters:
#  bamDuprm <- "test_duprm.bam"	# the duplicate marked bam file
#  gtf <- "genes.gtf"	# the gene model
#  stranded <- 2		# '0' (unstranded), '1' (stranded) and '2' (reversely stranded)
#  paired   <- FALSE	# is the library paired end?
#  threads  <- 4		# number of threads to be used
#  
#  # Duplication rate analysis
#  dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)

## ----fig.width=14,fig.height=7------------------------------------------------
## make a duprate plot (blue cloud)
par(mfrow=c(1,2))
duprateExpDensPlot(DupMat=dm)		# a good looking plot
title("good experiment")
duprateExpDensPlot(DupMat=dm.bad)	# a dataset with duplication problems
title("duplication problems")

## duprate boxplot
duprateExpBoxplot(DupMat=dm)		# a good looking plot
duprateExpBoxplot(DupMat=dm.bad)	# a dataset with duplication problems

## ----fig.width=7,fig.height=7-------------------------------------------------
duprateExpDensPlot(DupMat=dm)

# or, just to get the fitted model without plot
fit <- duprateExpFit(DupMat=dm)
cat("duprate at low read counts: ",fit$intercept,"\n",
	"progression of the duplication rate: ",fit$slope,fill=TRUE)

## ----eval=FALSE---------------------------------------------------------------
#  ## INTERACTIVE: identify single points on screen (name="ID" column of dm)
#  duprateExpPlot(DupMat=dm)		# a good looking plot
#  duprateExpIdentify(DupMat=dm)

## ----fig.width=14,fig.height=7------------------------------------------------
par(mfrow=c(1,2))
cols <- colorRampPalette(c("black","blue","green","yellow","red"))
duprateExpPlot(DupMat=dm,addLegend=FALSE)
duprateExpPlot(DupMat=dm.bad,addLegend=FALSE,nrpoints=10,nbin=500,colramp=cols)

## ----fig.width=7,fig.height=7-------------------------------------------------
readcountExpBoxplot(DupMat=dm)

## ----fig.width=7,fig.height=7-------------------------------------------------
expressionHist(DupMat=dm)

## -----------------------------------------------------------------------------
# calculate the fraction of multimappers per gene
dm$mhRate <- (dm$allCountsMulti - dm$allCounts) / dm$allCountsMulti
# how many genes are exclusively covered by multimappers
sum(dm$mhRate == 1, na.rm=TRUE)

# and how many have an RPKM (including multimappers) > 5
sum(dm$mhRate==1 & dm$RPKMMulti > 5, na.rm=TRUE)

# and which are they?
dm[dm$mhRate==1 & dm$RPKMMulti > 5, "ID"]

## ----fig.width=7,fig.height=7-------------------------------------------------
hist(dm$mhRate, 
     breaks=50, 
     col="red", 
     main="Frequency of multimapping rates", 
     xlab="Multimapping rate per gene", 
     ylab="Frequency")


## ----fig.width=7,fig.height=7-------------------------------------------------
# comparison of multi-mapping RPK and uniquely-mapping RPK
plot(log2(dm$RPK), 
     log2(dm$RPKMulti), 
     xlab="Reads per kb (uniquely mapping reads only)",
     ylab="Reads per kb (all including multimappers, non-weighted)"
)

## ----eval=F-------------------------------------------------------------------
#  identify(log2(dm$RPK),
#           log2(dm$RPKMulti),
#  	 labels=dm$ID)

## ----eval=F-------------------------------------------------------------------
#  library(dupRadar)
#  library(biomaRt)
#  
#  ## for detailed explanations on biomaRt, please see the respective
#  ## vignette
#  
#  ## set up biomart connection for mouse (needs internet connection)
#  ensm <- useMart("ensembl")
#  ensm <- useDataset("mmusculus_gene_ensembl", mart=ensm)
#  
#  ## get a table which has the gene GC content for the IDs that have been
#  ## used to generate the table (depends on the GTF annotation that you
#  ## use)
#  tr <- getBM(attributes=c("mgi_symbol", "percentage_gc_content"),
#              values=TRUE, mart=ensm)
#  
#  ## create a GC vector with IDs as element names
#  mgi.gc <- tr$percentage_gc_content
#  names(mgi.gc) <- tr$mgi_symbol
#  
#  ## using dm demo duplication matrix that comes with the package
#  ## add GC content to our demo data and keep only subset for which we can
#  ## retrieve data
#  keep <- dm$ID %in% tr$mgi_symbol
#  dm.gc <- dm[keep,]
#  dm.gc$gc <- mgi.gc[dm.gc$ID]
#  
#  ## check distribution of annotated gene GC content (in %)
#  boxplot(dm.gc$gc, main="Gene GC content", ylab="% GC")

## ----eval=F-------------------------------------------------------------------
#  par(mfrow=c(1,2))
#  
#  ## below median GC genes
#  duprateExpDensPlot(dm.gc[dm.gc$gc<=45,], main="below median GC genes")
#  
#  ## above median GC genes
#  duprateExpDensPlot(dm.gc[dm.gc$gc>=45,], main="above median GC genes")

## ----eval=F-------------------------------------------------------------------
#  #!/usr/bin/env Rscript
#  
#  ########################################
#  ##
#  ## dupRadar shell script
#  ## call dupRadar R package from the shell for
#  ## easy integration into pipelines
#  ##
#  ## Holger Klein & Sergi Sayols
#  ##
#  ## https://github.com/ssayols/dupRadar
#  ##
#  ## input:
#  ## - _duplicate marked_ bam file
#  ## - gtf file
#  ## - parameters for duplication counting routine:
#  ##   stranded, paired, outdir, threads.
#  ##
#  ########################################
#  
#  library(dupRadar)
#  
#  ####################
#  ##
#  ## get name patterns from command line
#  ##
#  args   <- commandArgs(TRUE)
#  
#  ## the bam file to analyse
#  bam <- args[1]
#  ## usually, same GTF file as used in htseq-count
#  gtf <- gsub("gtf=","",args[2])
#  ## no|yes|reverse
#  stranded <- gsub("stranded=","",args[3])
#  ## is a paired end experiment
#  paired   <- gsub("paired=","",args[4])
#  ## output directory
#  outdir   <- gsub("outdir=","",args[5])
#  ## number of threads to be used
#  threads  <- as.integer(gsub("threads=","",args[6]))
#  
#  if(length(args) != 6) {
#    stop (paste0("Usage: ./dupRadar.sh <file.bam> <genes.gtf> ",
#  			   "<stranded=[no|yes|reverse]> paired=[yes|no] ",
#  			   "outdir=./ threads=1"))
#  }
#  
#  if(!file.exists(bam)) {
#    stop(paste("File",bam,"does NOT exist"))
#  }
#  
#  if(!file.exists(gtf)) {
#    stop(paste("File",gtf,"does NOT exist"))
#  }
#  
#  if(!file.exists(outdir)) {
#    stop(paste("Dir",outdir,"does NOT exist"))
#  }
#  
#  if(is.na(stranded) | !(grepl("no|yes|reverse",stranded))) {
#    stop("Stranded has to be no|yes|reverse")
#  }
#  
#  if(is.na(paired) | !(grepl("no|yes",paired))) {
#    stop("Paired has to be no|yes")
#  }
#  
#  if(is.na(threads)) {
#    stop("Threads has to be an integer number")
#  }
#  
#  stranded <- if(stranded == "no") 0 else if(stranded == "yes") 1 else 2
#  
#  ## end command line parsing
#  ##
#  ########################################
#  
#  ########################################
#  ##
#  ## analyze duprates and create plots
#  ##
#  cat("Processing file ", bam, " with GTF ", gtf, "\n")
#  
#  ## calculate duplication rate matrix
#  dm <- analyzeDuprates(bam,
#                        gtf,
#                        stranded,
#                        (paired == "yes"),
#                        threads)
#  
#  ## produce plots
#  
#  ## duprate vs. expression smooth scatter
#  png(file=paste0(outdir,"/",gsub("(.*)\\.[^.]+","\\1",basename(bam)),"_dupRadar_drescatter.png"),
#      width=1000, height=1000)
#  duprateExpDensPlot(dm, main=basename(bam))
#  dev.off()
#  
#  ## expression histogram
#  png(file=paste0(outdir,"/",gsub("(.*)\\.[^.]+","\\1",basename(bam)),"_dupRadar_ehist.png"),
#      width=1000, height=1000)
#  expressionHist(dm)
#  dev.off()
#  
#  ## duprate vs. expression boxplot
#  png(file=paste0(outdir,"/",gsub("(.*)\\.[^.]+","\\1",basename(bam)),"_dupRadar_drebp.png"),
#      width=1000, height=1000)
#  par(mar=c(10,4,4,2)+.1)
#  duprateExpBoxplot(dm, main=basename(bam))
#  dev.off()

## ----citation-----------------------------------------------------------------
citation("dupRadar")

## ----echo=FALSE---------------------------------------------------------------
sessionInfo()

#' Draw histogram with the expression values
#'
#' \code{expressionHist} Draw histogram with the expression values
#'
#' This function draws a histogram of the expression values from the
#' duplication matrix calculated by \code{analyzeDuprates}.
#'
#' @param DupMat The duplication matrix calculated by \code{analyzeDuprates}
#' @param value The column from the duplication matrix containing the
#'   expression values
#' @param ... Other parameters sent to hist()
#' @return nothing
#' @examples
#' # dm is a duplication matrix calculated by analyzeDuprates:
#' # R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
#' attach(dupRadar_examples)
#'
#' # histogram of expression values for annotation
#' expressionHist(DupMat=dm)
#' @export
expressionHist <- function(DupMat, value="RPK", ...) {
    hist(log10(DupMat[,value]),
         axes=FALSE,
         breaks=100,
         xlab="reads per kilobase (RPK)",
         main="",
         ...)
    r <- round(range(log10(DupMat[,"RPK"]), finite=TRUE))
    s <- seq(r[1], r[2], 1)
    axis(2)
    axis(1, labels=10^s, at=s)
    abline(v=3, col="red")
}

#' Dynamic range
#'
#' \code{getDynamicRange} Calculate the dynamic range of the RNAseq experiment
#'
#' This function calculates the dynamic range of the RNAseq eperiment
#'
#' @param dm The duplication matrix calculated by \code{analyzeDuprates}
#' @return A list with 2 elements, containing the dynamic range counting all
#' reads and the dynamic range after removing duplicates.
#' @examples
#' # dm is a duplication matrix calculated by analyzeDuprates:
#' # R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
#' attach(dupRadar_examples)
#'
#' # calculate the dynamic range
#' getDynamicRange(dm)
#' @export
getDynamicRange <- function(dm) {

  step <- 0.01
  qvec <- seq(step, 1, step)
  
  medianrpkm<- function(p, dm, col) {
    ## generate a subset of the matrix for read counts in a given bin
    tm <- dm[dm[,col] <  quantile(dm[,col], p) &
             dm[,col] >= quantile(dm[,col], p-step),]
    return(median(tm[,col]))
  }

  ## calculate dynamic range:
  ## (median highest 1% expressed / median lowest 1% expressed)
  
  ## median bin counts (all)
  mbc.a <- sapply(qvec, medianrpkm, dm, "RPKM")
  dr.a <- mbc.a[length(mbc.a)]/mbc.a[mbc.a>0 & !is.na(mbc.a)][1]

  ## median bin counts (duprm)
  dm$RPKMU <- (1 - dm$dupRate) * dm$RPKM
  dm$RPKMU <- ifelse(is.na(dm$RPKMU),dm$RPKM,dm$RPKMU)
  mbc.u <- sapply(qvec, medianrpkm, dm, "RPKMU");
  dr.u  <- mbc.u[length(mbc.u)]/mbc.u[mbc.u>0 & !is.na(mbc.u)][1]

  return(list("dynrange.all"=dr.a,
              "dynrange.duprm"=dr.u))
  
}

#' Duplication rate ~ total read count plot
#'
#' \code{duprateExpDensPlot} Duplication rate ~ total read count plot
#'
#' This function makes a scatter plot showing the per gene duplication rate
#' versus the total read count.
#'
#' @param DupMat The duplication matrix calculated by \code{analyzeDuprates}
#' @param pal The color palette to use to display the density
#' @param tNoAlternative Display threshold of 1000 reads per kilobase
#' @param tRPKM Display threshold at a given RPKM level
#' @param tRPKMval The given RPKM level
#' @param tFit Whether to fit the model
#' @param addLegend Whether to add a legend to the plot
#' @param ... Other parameters sent to plot()
#' @return nothing
#' @examples
#' # dm is a duplication matrix calculated by analyzeDuprates:
#' # R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
#' attach(dupRadar_examples)
#'
#' # duprate plot
#' duprateExpDensPlot(DupMat=dm)
#' @export
duprateExpDensPlot <- function(DupMat,
                               pal=c("cyan","blue","green","yellow","red"), 
                               tNoAlternative=TRUE, tRPKM=TRUE, tRPKMval=0.5, 
                               tFit=TRUE, addLegend=TRUE,
                               ...) {
  
  x <- log10(DupMat$RPK)
  y <- 100*DupMat$dupRate
  
  ## density-coloured scatterplot
  cols  <- colorRampPalette(pal)
  dcols <- densCols(x=x,y=y,colramp=cols,nbin=500)
  xaxs  <- seq(min(x[!is.infinite(x)]),max(x),length.out=5)
  yaxs  <- seq(0,100,length.out=5)
  plot(x=x,y=y,
       col=dcols,
       pch=20,cex=.25,
       axes=FALSE,xlab="expression (reads/kbp)",
       ylab="% duplicate reads",
       ylim=c(0,100),
       ...)
  Axis(side=2,at=yaxs,labels=as.character(round(yaxs,2)), las=2)

  ## r <- round(range(log10(DupMat[,"RPK"]/DupMat[,"geneLength"]), finite=TRUE))

  r <- round(range(log10(DupMat[,"RPK"]), finite=TRUE))
  s <- seq(r[1], r[2], 1)
  Axis(side=1, labels=10^s, at=s)
  
  ## fit logistic regression model
  if(tFit) {
      fit <- duprateExpFit(DupMat)
      if(class(fit)[1] != "try-error") { 
          lines(sort(x),
                100*predict(fit$glm,data.frame(x=sort(x)),type="response"),
                col="black",lwd=2,lty=3)
          legend("topleft", legend=c(paste("Int:", round(fit$intercept,2)),
                                paste("Sl:" , round(fit$slope,2))))
          
      }
  }
  
  ## threshold of 1000 reads per kilobase ( log10(1000)=3 )
  ## -> no way to put more than 1000 reads on 1000bp without duplication
  if (tNoAlternative) {
    abline(v=log10(1000), col="red", lty=2)
  }
  
  ## threshold at given RPKM level default: 0.5
  if (tRPKM) {
    ## get the RPK for the closest greater value of RPKM in question 
    RPKgt <- sort(DupMat[DupMat[,"RPKM"]>=tRPKMval,"RPK"])[1]
    ## get the RPK for the closest greater value of RPKM in question
    RPKlt <- sort(DupMat[DupMat[,"RPKM"]<=tRPKMval,"RPK"], decreasing=TRUE)[1]
    RPKMthreshold <- mean(RPKgt, RPKlt)
    abline(v=log10(RPKMthreshold), col="green", lty=2)
  }
  
  if (addLegend) {
    text <- c()
    col  <- c()
    
    if (tNoAlternative) {
      text <- c(text, "1 read/bp")
      col  <- c(col, "red")
    }
    
    if (tRPKM) {
      text <- c(text, paste(tRPKMval, "RPKM"))
      col  <- c(col, "green")
    }
    legend("bottomright",
           legend=text,
           col=col,
           lty=2)
  }
}

#' Program dispatchers to mark duplicated reads from a BAM file
#'
#' \code{markDuplicates} Mark duplicated reads from a BAM file by calling
#'   widely used tools.
#'
#' This function works as a wrapper for several tools widely adopted tr mark
#' duplicated reads in a BAM file. Currently, it supports PICARD and BamUtils.
#'
#' @param dupremover The tool to be called. Currently, "picard" and "bamutils"
#'   are supported
#' @param bam The bam file to mark duplicates from
#' @param out Regular expression describing the transformation on the original
#'   filename to get the output filename. By default, a "_duprm" suffix is 
#'   added before the bam extension
#' @param rminput Whether to keep the original, non duplicate-marked, bam file
#' @param path Path to the duplicate marker binaries
#' @param verbose Redirect all the program output to the R console
#' @param ... Other parameters sent to the caller function
#' @return The output filename
#' @examples
#' \dontrun{
#' bam <- system.file("extdata","sample1Aligned.out.bam",package="dupRadar")
#' gtf <- "genes.gtf"
#' stranded <- 2    # '0' (unstranded), '1' (stranded) and '2' (reverse)
#' paired   <- FALSE
#' threads  <- 4
#' 
#' # call the duplicate marker and analyze the reads
#' bamDuprm <- markDuplicates(dupremover="bamutil",bam,
#'                            path="/opt/bamUtil-master/bin",rminput=FALSE)
#' dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
#' }
#' @export
markDuplicates <- function(dupremover=c("bamutil", "picard"),
                           bam=NULL,
                           out=gsub("\\.bam$","_duprm.bam",bam),
                           rminput=TRUE,
                           path=".",
                           verbose=TRUE,...) {

    # check input parms
    dupremover <- match.arg(dupremover)
    if(!file.exists(bam))  stop("file",bam,"not found!")
    if(!file.exists(path)) stop("dir",path,"not found!")
    if(!file.exists(dirname(out))) {
        if(verbose) cat("creating dir:",dirname(out),fill=TRUE)
        dir.create(dirname(out),recursive=TRUE)
    }

    # dispatch the function
    switch(dupremover,
           picard =picardMarkDuplicates (bam=bam,out=out,path=path,verbose=verbose,...),
           bamutil=bamutilMarkDuplicates(bam=bam,out=out,path=path,verbose=verbose,...))

    # remove non duplicate-marked bam file
    if(rminput) file.remove(bam)

    invisible(out)
}

#' Mark duplicates using Picard tools
#'
#' \code{picardMarkDuplicates} Mark duplicated reads from a BAM file by calling
#'   picard tools
#'
#' This function is supposed to be called through the \code{markDuplicates}
#'   wrapper
#'
#' @param bam The bam file to mark duplicates from
#' @param out Regular expression describing the transformation on the original
#'   filename to get the output filename. By default, a "_duprm" suffix is
#'   added before the bam extension
#' @param path Path to the duplicate marker binaries
#' @param verbose Redirect all the program output to the R console
#' @param threads Number of threads to use
#' @param maxmem Max memory assigned to the jvm
#' @return The return code of the system call
picardMarkDuplicates <- function(bam,out,path,verbose,threads=1,maxmem="4g") {

    # call picard MarkDuplicates
    cmd <- paste0(" -XX:ParallelGCThreads=",threads,
                  " -Xmx",maxmem,
                  " -jar ",file.path(path,"picard.jar"),
                  " MarkDuplicates",
                  " INPUT=",bam,
                  " OUTPUT=",out,
                  " METRICS_FILE=",gsub("\\.bam$","_picard_metrics.txt",bam),
                  " REMOVE_DUPLICATES=false",
                  " ASSUME_SORTED=true",
                  " PROGRAM_RECORD_ID=\'null\'")

    if(verbose) cat(paste("Running",cmd),fill=TRUE)
    rc <- system2("java",cmd,stdout=ifelse(verbose,"","FALSE"),
                  stderr=ifelse(verbose,"","FALSE"))

    # check RC
    if(rc == 127) stop("command java",cmd,"could not be run!")
    if(rc != 0)   stop("picard returned error code",rc,"in command: java",cmd)
    invisible(rc)
}


#' Mark duplicates using bamutil
#'
#' \code{bamutilMarkDuplicates} Mark duplicated reads from a BAM file by
#'   calling bamutil
#'
#' This function is supposed to be called through the \code{markDuplicates}
#'   wrapper
#'
#' @param bam The bam file to mark duplicates from
#' @param out Regular expression describing the transformation on the original
#'   filename to get the output filename. By default, a "_duprm" suffix is
#'   added before the bam extension
#' @param path Path to the duplicate marker binaries
#' @param verbose Redirect all the program output to the R console
#' @return The return code of the system call
bamutilMarkDuplicates <- function(bam,out,path,verbose) {

    # call bamutil dedup
    cmd <- paste("dedup --in",bam,"--out",out)

    if(verbose) cat(paste("Running",cmd),fill=TRUE)
    rc <- system2(file.path(path,"bam"),cmd,stdout=ifelse(verbose,"","FALSE"),
                  stderr=ifelse(verbose,"","FALSE"))

    # check RC
    if(rc == 127) stop("command bam",cmd,"could not be run!")
    if(rc != 0)   stop("bamutil returned error code",rc,"in command: bam",cmd)
    invisible(rc)
}

#' Helper function used in \code{getBinDuplication} and
#'   \code{getBinRpkMean}
#'
#' \code{getDupMatBin} get a subset of the matrix for values in a specific bin
#' defined by the upper bound p and stepSize
#'
#' @param p The vector of bins
#' @param stepSize The window size
#' @param value The column to be subset
#' @param DupMat The duplication matrix calculated by \code{analyzeDuprates}
#' @return The subseted matrix
#' @export
getDupMatBin <- function(p, stepSize=0.05, value="allCounts", DupMat) {
    ## subset of the matrix for values in a specific bin
    ## defined by the upper bound p and stepSize
    dupMatBin <- DupMat[DupMat[,value] <
                        quantile(DupMat[,value], p) &
                        DupMat[,value] >=
                        quantile(DupMat[,value], p - stepSize),]
    
    return(dupMatBin)
}

#' Duplication rate ~ total read count plot
#'
#' \code{duprateExpPlot} Duplication rate ~ total read count plot
#'
#' This function makes a smooth scatter plot showing the per gene duplication 
#' rate versus the total read count.
#'
#' @param DupMat The duplication matrix calculated by \code{analyzeDuprates}
#' @param tNoAlternative Display threshold of 1000 reads per kilobase
#' @param tRPKM Display threshold at a given RPKM level
#' @param tRPKMval The given RPKM level
#' @param addLegend Whether to add a legend to the plot
#' @param ... Other parameters sent to smoothScatter()
#' @return nothing
#' @examples
#' # dm is a duplication matrix calculated by analyzeDuprates:
#' # R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
#' attach(dupRadar_examples)
#'
#' # duprate plot
#' duprateExpPlot(DupMat=dm)
#' @export
duprateExpPlot <- function(DupMat,
                           tNoAlternative=TRUE,
                           tRPKM=TRUE,
                           tRPKMval=0.5,
                           addLegend=TRUE,
                           ...) {
    smoothScatter(log10(DupMat[,"RPK"]),
                  100*DupMat[,"dupRate"],
                  xlab="expression level (reads/kbp)",
                  ylab="duplication level (% duplicate reads)",
                  axes=FALSE,
                  ylim=c(0,100),
                  ...)
    axis(2)

    ## FIX: axis annotation is too short if we take the range of RPKM
    ## instead of the range of RPK
    ## r <- round(range(log10(DupMat[,"RPK"]/DupMat[,"geneLength"]), finite=TRUE))
    r <- round(range(log10(DupMat[,"RPK"]), finite=TRUE))
    s <- seq(r[1], r[2], 1)
    axis(1, labels=10^s, at=s)
  
    ## threshold of 1000 reads per kilobase
    ## ( log10(1000)=3 )
    ## -> no way to put more than 1000 reads on 1000bp
    ## without duplication
    if (tNoAlternative) {
        ## 
        abline(v=log10(1000), col="red", lty=2)
    }
  
    ## threshold at given RPKM level
    ## default: 0.5
    if (tRPKM) {
        ## get the RPK for the closest greater value of RPKM in question 
        RPKgt <- sort(DupMat[DupMat[,"RPKM"]>=tRPKMval,"RPK"])[1]
        ## get the RPK for the closest greater value of RPKM in question
        RPKlt <- sort(DupMat[DupMat[,"RPKM"]<=tRPKMval,"RPK"], decreasing=TRUE)[1]
        RPKMthreshold <- mean(RPKgt, RPKlt)
        abline(v=log10(RPKMthreshold), col="green", lty=2)
    }
  
    if (addLegend) {
        text <- c()
        col  <- c()
        
        if (tNoAlternative) {
            text <- c(text, "1 read/bp")
            col  <- c(col, "red")
        }
    
        if (tRPKM) {
            text <- c(text, paste(tRPKMval, "RPKM"))
            col  <- c(col, "green")
        }
        legend("bottomright",
               legend=text,
               col=col,
               lty=2)
    }
}

#' Helper function used in \code{duprateExpBoxplot}
#'
#' \code{getBinDuplication} get duplication rate for a subset of the
#' duplication matrix
#'
#' @param p The vector of bins
#' @param stepSize The window size
#' @param DupMat The duplication matrix calculated by \code{analyzeDuprates}
#' @return The duplication rate per bin
#' @export
getBinDuplication <- function(p, stepSize, DupMat) {
    ## get subset of DupMat
    dupMatBin <- getDupMatBin(p=p,
                              stepSize=stepSize,
                              value="RPK",
                              DupMat=DupMat)
    
    binDuprates <- dupMatBin[,"dupRate"]
  
    return(binDuprates)
}

#' dupRadar.
#'
#' Duplication rate quality control for RNA-Seq datasets.
#'
#' @name dupRadar
#' @docType package
#' @import Rsubread 
#' @import KernSmooth
#' @importFrom grDevices colorRampPalette densCols
#' @importFrom graphics Axis abline axis barplot boxplot hist identify legend lines par smoothScatter title
#' @importFrom stats binomial coef glm median predict quantile
#' @importFrom utils capture.output
NULL

#' Example data containing precomputed matrices for two RNASeq experiments
#'
#' Precomputed duplication matrices for two RNASeq experiments used as examples
#' of a good and a failed (in terms of high redundancy of reads) experiments. 
#' The experiments come from the ENCODE project, as a source of a broad variety
#' of protocols, library types and sequencing facilities.
#'
#' @docType data
#' @keywords datasets
#' @name dupRadar_examples
#' @usage data(dupRadar_examples)
#' @format A list with two example duplication matrices
NULL

#' Duplication matrix of a good RNASeq experiment
#'
#' A dataset containing the duplication matrix of a good RNASeq experiment, in
#' terms of duplicates. Comes from the GM12878 SR1x75 replicate 2 from Caltech
#' (UCSC's table Browser name: wgEncodeCaltechRnaSeqGm12878R1x75dAlignsRep2V2)
#'
#' @docType data
#' @keywords datasets
#' @name dm
#' @usage data(dupRadar_examples)
#' @format A data frame with 23228 rows and 14 variables
NULL

#' Duplication matrix of a failed RNASeq experiment
#'
#' A dataset containing the duplication matrix of a failed RNASeq experiment,
#' containing unusual duplication rate. Comes from the HCT116 PE2x75 replicate 1
#' from Caltech (UCSC's table Browser name: 
#' wgEncodeCaltechRnaSeqHct116R2x75Il200AlignsRep1V2)
#'
#' @docType data
#' @keywords datasets
#' @name dm.bad
#' @usage data(dupRadar_examples)
#' @format A data frame with 23228 rows and 14 variables
NULL
#> NULL

#' Helper function used in \code{readcountExpressionBoxplot}
#'
#' \code{readcountExpressionBoxplot} Calculates the fraction of total reads in
#'   a vector of bins
#'
#' @param p The vector of bins
#' @param stepSize The window size
#' @param DupMat The duplication matrix calculated by \code{analyzeDuprates}
#' @return The fraction of total reads in a vector of bins
#' @export
getRpkBinReadCountFraction <- function(p, stepSize=stepSize, DupMat=DupMat) {

    ## generate a subset of the matrix for RPK values given bin
    ## defined by the upper bound p and the lower bound p-step
    tm<-DupMat[DupMat[,"RPK"] <  quantile(DupMat[,"RPK"], p) &
               DupMat[,"RPK"] >= quantile(DupMat[,"RPK"], p-stepSize),]
    
    ## calculate the fraction of total reads in given bin
    BinReadFraction <- sum(tm[,"allCounts"])/sum(DupMat[,"allCounts"])
    return(BinReadFraction)
}

#' Helper function used in \code{duprateExpBoxplot}
#'
#' \code{getBinRpkMean} get mean duplication rate per bin
#'
#' @param p The vector of bins
#' @param stepSize The window size
#' @param DupMat The duplication matrix calculated by \code{analyzeDuprates}
#' @return The averaged RPK per bin
#' @export
getBinRpkMean <- function(p, stepSize, DupMat) {
    ## get subset of DupMat 
    dupMatBin <- getDupMatBin(p=p,
                              stepSize=stepSize,
                              value="RPK",
                              DupMat=DupMat)
    
    binRpkMean <- round(mean(dupMatBin[,"RPK"]), 1)
    
    return(binRpkMean)
}

#' Helper function used in \code{readcountExpressionBoxplot}
#'
#' \code{getRpkCumulativeReadCountFraction} get the cumulative read count
#'   fraction
#'
#' @param p The vector of bins
#' @param DupMat The duplication matrix calculated by \code{analyzeDuprates}
#' @return The cumulative read count fraction
#' @export
getRpkCumulativeReadCountFraction <- function(p, DupMat=DupMat) {

    ## generate a subset of the matrix for RPK values < than RPK percentile p
    tm <- DupMat[DupMat[,"RPK"] < quantile(DupMat[,"RPK"], p),]
    ## calculate the global duplication rate for the remaining values
    ReadFractionBelowP <- (sum(tm[,"dupsPerId"])/sum(tm[,"allCounts"]))
    
    return(ReadFractionBelowP)
}

#' Barplot showing the cumulative read counts fraction
#'
#' \code{cumulativeDuprateBarplot} Barplot showing the cumulative read counts
#'   fraction
#'
#' This function makes a barplot showing the cumulative read counts fraction
#' from the duplication matrix calculated by \code{analyzeDuprates}.
#'
#' @param DupMat The duplication matrix calculated by \code{analyzeDuprates}
#' @param stepSize The size of the windows used for plotting
#' @param ... Other params sent to barplot
#' @return nothing 
#' @examples
#' # dm is a duplication matrix calculated by analyzeDuprates:
#' # R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
#' attach(dupRadar_examples)
#'
#' # call the plot
#' cumulativeDuprateBarplot(DupMat=dm)
#' @export
cumulativeDuprateBarplot <- function(DupMat, stepSize=0.05, ...) {
    ## Attention 1:
    ## Usually we have a certain amount of genes in our tables that have
    ## no reads at all.
    ## In these cases the duplication rate is NaN, so no points will be
    ## plotted for these. Thus the resulting plot seems to end at low
    ## expression rates.
    ## We can see from the lower percentile for which there is a point,
    ## which fraction of genes is non-expressed in the current dataset
    ##
    ## Attention 2:
    ## The global duplication rate can increase with decreasing RPKM percentiles.
    ## 
    ##
    
    vec <- seq(0, 1, stepSize)
    
    barplot(sapply(vec,
                   getRpkCumulativeReadCountFraction,
                   DupMat),
            names=as.character(vec*100),
            las=2,
            ylim=c(0,1),
            ylab="duplication rate",
            xlab="percentile RPK",
            main="global dup rate <= RPK percentile",
            ...)
    
    
}

#' Identify genes plotted by \code{duprateExpPlot}
#'
#' \code{duprateExpIdentify} Identify genes plotted by \code{duprateExpPlot}
#'
#' This function makes a barplot showing the cumulative read counts fraction
#' from the duplication matrix calculated by \code{analyzeDuprates}.
#'
#' @param DupMat The duplication matrix calculated by \code{analyzeDuprates}
#' @param idCol The column from the duplication matrix containing the labels
#' @return The identified points. \code{x} and \code{y} values match the ones 
#'  from \code{duprateExpPlot}
#' @examples
#' # dm is a duplication matrix calculated by analyzeDuprates:
#' # R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
#' attach(dupRadar_examples)
#'
#' # call the plot and identify genes
#' duprateExpPlot(DupMat=dm)
#' duprateExpIdentify(DupMat=dm)
#' @export
duprateExpIdentify <- function(DupMat, idCol="ID") {
    marked <- identify(log10(DupMat[,"RPK"]),
                       100*DupMat[,"dupRate"],
                       labels=DupMat[,idCol])
    return(marked)
}

#' Read in a BAM file and count the tags falling on the features described
#' in the GTF file
#'
#' \code{analyzeDuprates} returns a data.frame with tag counts
#'
#' This function makes use of the Rsubread package to count tags on the GTF
#' features in different scenarios. The scenarios are the 4 possible
#' combinations of allowing multimappers (yes/no) and duplicate reads (yes/no).
#'
#' @param bam The bam file containing the duplicate-marked reads
#' @param gtf The gtf file describing the features
#' @param stranded Whether the reads are strand specific
#' @param paired Paired end experiment?
#' @param threads The number of threads to be used for counting
#' @param verbose Whether to output Rsubread messages into the console
#' @param tmpDir Directory for temporary files created by featureCounts (default: ".")
#' @param ... Other params sent to featureCounts
#' @return A data.frame with counts on features, with and without taking into
#'   account multimappers/duplicated reads
#' @examples
#' bam <- system.file("extdata",
#'     "wgEncodeCaltechRnaSeqGm12878R1x75dAlignsRep2V2_duprm.bam",
#'     package = "dupRadar"
#' )
#' gtf <- system.file("extdata", "genes.gtf", package = "dupRadar")
#' stranded <- 2 # '0' (unstranded), '1' (stranded) and '2' (reverse)
#' paired <- FALSE
#' threads <- 4
#'
#' # call the duplicate marker and analyze the reads
#' dm <- analyzeDuprates(bam, gtf, stranded, paired, threads)
#'
#' # use a different directory for temporary files (e.g., for FUSE filesystem issues)
#' dm <- analyzeDuprates(bam, gtf, stranded, paired, threads, tmpDir = "/tmp")
#' @export
analyzeDuprates <- function(bam, gtf, stranded = 0, paired = FALSE, threads = 1,
                            verbose = FALSE, tmpDir = ".", ...) {
    # check input parameters
    if (!file.exists(bam)) stop("file", bam, "not found!")
    if (!file.exists(gtf)) stop("file", gtf, "not found!")
    if (!is.logical(paired)) stop("paired has to be either TRUE/FALSE")
    if (!is.numeric(stranded)) stop("stranded has to be a number [0-2]")
    if (stranded < 0 || stranded > 2) stop("stranded has to be a number [0-2]")
    if (!is.numeric(threads)) stop("threads has to be a number")
    if (!is.character(tmpDir)) stop("tmpDir has to be a character string")
    if (!dir.exists(tmpDir)) stop("tmpDir '", tmpDir, "' does not exist!")

    # featureCounts simplified call
    count <- function(mh, dup) {
        Rsubread::featureCounts(
            files = bam,
            annot.ext = gtf,
            isGTFAnnotationFile = TRUE,
            nthreads = threads,
            isPairedEnd = paired,
            strandSpecific = stranded,
            ignoreDup = dup,
            countMultiMappingReads = mh,
            tmpDir = tmpDir,
            ...
        )
    }

    ## HK: status info for each call of featureCounts()? In silent mode it's
    ## not obvious any more what is happening. This would require assigning the
    ## results to individual variables first and generating the list afterwards.
    if (verbose) {
        counts <- list(
            mhdup = count(mh = TRUE, dup = FALSE),
            mhnodup = count(mh = TRUE, dup = TRUE),
            nomhdup = count(mh = FALSE, dup = FALSE),
            nomhnodup = count(mh = FALSE, dup = TRUE)
        )
    } else {
        ## assign output on STDOUT from featureCounts to variable silencer,
        ## which we ignore afterwards.
        silencer <- capture.output(
            counts <- list(
                mhdup = count(mh = TRUE, dup = FALSE),
                mhnodup = count(mh = TRUE, dup = TRUE),
                nomhdup = count(mh = FALSE, dup = FALSE),
                nomhnodup = count(mh = FALSE, dup = TRUE)
            )
        )
    }

    # calculate RPK & RPKM per gene
    x <- lapply(counts, function(x) {
        # total number of mapped reads
        N <- sum(x$stat[, 2]) - x$stat[x$stat$Status == "Unassigned_Unmapped", 2]

        x <- data.frame(
            gene = rownames(x$counts),
            width = x$annotation$Length[match(rownames(x$counts), x$annotation$GeneID)],
            counts = x$counts[, 1],
            RPK = 0,
            RPKM = 0
        )
        x$RPK <- x$counts * (10^3 / x$width)
        x$RPKM <- x$RPK * (10^6 / N)

        return(x)
    })

    # calculate duprates per gene, count duplicates per gene
    x <- data.frame(
        ID = x[[1]]$gene,
        geneLength = x[[1]]$width,
        allCountsMulti = x[[1]]$counts,
        filteredCountsMulti = x[[2]]$counts,
        dupRateMulti = (x[[1]]$counts - x[[2]]$counts) / x[[1]]$counts,
        dupsPerIdMulti = x[[1]]$counts - x[[2]]$counts,
        RPKMulti = x[[1]]$RPK,
        PKMMulti = x[[1]]$RPKM,
        allCounts = x[[3]]$counts,
        filteredCounts = x[[4]]$counts,
        dupRate = (x[[3]]$counts - x[[4]]$counts) / x[[3]]$counts,
        dupsPerId = x[[3]]$counts - x[[4]]$counts,
        RPK = x[[3]]$RPK,
        RPKM = x[[3]]$RPKM
    )
}

#' Duplication rate ~ total read count fit model
#'
#' \code{duprateExpDensPlot} Duplication rate ~ total read count fit model
#'
#' Fit a Generalized Linear Model using a logit function between thegene 
#' duplication rate and the total read count.
#'
#' @param DupMat The duplication matrix calculated by \code{analyzeDuprates}
#' @return The GLM and the coefficients of the fitted logit function
#' @examples
#' # dm is a duplication matrix calculated by analyzeDuprates:
#' # R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
#' attach(dupRadar_examples)
#'
#' # duprate plot
#' duprateExpFit(DupMat=dm)
#' @export
duprateExpFit <- function(DupMat) {
  
	x <- log10(DupMat$RPK)
	y <- DupMat$dupRate
  
	fit <- try(suppressWarnings(glm(y ~ x,family=binomial(link="logit"))))
	
	## alternative:
	## fit without the 0% duprate genes (mostly loci with only 1 read)
	## Note: result deviates more strongly from our empirical distribution 
	## than taking all
	## yclean <- y[y!=0]
	## xclean <- x[y!=0]
	## fit <- try(suppressWarnings(glm(yclean ~ xclean,
	##                                 family=binomial(link="logit"))))
	## newx <- sort(xclean)
	## newy <- predict(fit,data.frame(xclean=sort(xclean)),type="response")
	if(class(fit)[1] != "try-error") {
		x <- exp(coef(fit))
		fit <- list(glm=fit,
                            intercept=x[1],
                            slope=x[2])
            }
        
	return(fit)
    }

#' Barplot of percentage of reads falling into expression bins
#'
#' \code{readcountExpBoxplot} Barplot of percentage of reads falling into 
#' expression bins
#'
#' This function makes a barplot of percentage of reads falling into expression
#' bins
#'
#' @param DupMat The duplication matrix calculated by \code{analyzeDuprates}
#' @param stepSize The number of bars to be shown
#' @param ... Other parameters sent to barplot()
#' @return nothing Other parameters sent to barplot()
#' @examples
#' # dm is a duplication matrix calculated by analyzeDuprates:
#' # R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
#' attach(dupRadar_examples)
#'
#'
#' # barplot of percentage of reads falling into expression bins
#' readcountExpBoxplot(DupMat=dm)
#' @export
readcountExpBoxplot <- function(DupMat, stepSize=0.05, ...) {

    ## define bin upper bounds
    binVec <- seq(stepSize, 1, stepSize)
  
    ## read counts in each RPK bin
    RpkBinReadCounts <- sapply(binVec,
                               getRpkBinReadCountFraction,
                               DupMat=DupMat,
                               stepSize=stepSize)
    
    names(RpkBinReadCounts) <- paste(as.character(binVec - stepSize),
                                     as.character(binVec), sep="-")
  
    barplot(RpkBinReadCounts,
            ylim=c(0,1),
            las=3,
            ylab="% of total reads in expression bin",
            main="Percentage of Reads in Expression Bin.",
            ...)
    
    title(xlab="expression bin", line=8)
  
}

#' Report duplication stats on regions
#'
#' \code{getDupMatStats} Report duplication stats based on the data calculated
#'   in the duplication matrix
#'
#' @param DupMat The duplication matrix calculated by \code{analyzeDuprates}
#' @return A data.frame containing the stats about the number of genes covered
#'   (1+ tags) and the number of genes containing duplicates (1+)
#' @examples
#' # dm is a duplication matrix calculated by analyzeDuprates:
#' # R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
#' attach(dupRadar_examples)
#'
#' # call the plot and identify genes
#' getDupMatStats(DupMat=dm)
#' @export
getDupMatStats <- function(DupMat) {

    nRegions <- nrow(DupMat)
    nRegionsCovered <- nrow(DupMat[DupMat[,"allCounts"]>0,])
    fRegionsCovered <- nRegionsCovered/nRegions
    nRegionsDuplication <- nrow(DupMat[DupMat[,"dupRate"]>0,])
    fRegionsDuplication <- nRegionsDuplication/nRegions
    fCoveredRegionsDuplication <- nRegionsDuplication/nRegionsCovered

    return(c(nRegions=nRegions,
             nRegionsCovered=nRegionsCovered,
             fRegionsCovered=fRegionsCovered,
             nRegionsDuplication=nRegionsDuplication,
             fRegionsDuplication=fRegionsDuplication,
             fCoveredRegionsDuplication=fCoveredRegionsDuplication))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/markDuplicates.R
\name{bamutilMarkDuplicates}
\alias{bamutilMarkDuplicates}
\title{Mark duplicates using bamutil}
\usage{
bamutilMarkDuplicates(bam, out, path, verbose)
}
\arguments{
\item{bam}{The bam file to mark duplicates from}

\item{out}{Regular expression describing the transformation on the original
filename to get the output filename. By default, a "_duprm" suffix is
added before the bam extension}

\item{path}{Path to the duplicate marker binaries}

\item{verbose}{Redirect all the program output to the R console}
}
\value{
The return code of the system call
}
\description{
\code{bamutilMarkDuplicates} Mark duplicated reads from a BAM file by
  calling bamutil
}
\details{
This function is supposed to be called through the \code{markDuplicates}
  wrapper
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/duprateExpPlot.R
\name{duprateExpPlot}
\alias{duprateExpPlot}
\title{Duplication rate ~ total read count plot}
\usage{
duprateExpPlot(DupMat, tNoAlternative = TRUE, tRPKM = TRUE,
  tRPKMval = 0.5, addLegend = TRUE, ...)
}
\arguments{
\item{DupMat}{The duplication matrix calculated by \code{analyzeDuprates}}

\item{tNoAlternative}{Display threshold of 1000 reads per kilobase}

\item{tRPKM}{Display threshold at a given RPKM level}

\item{tRPKMval}{The given RPKM level}

\item{addLegend}{Whether to add a legend to the plot}

\item{...}{Other parameters sent to smoothScatter()}
}
\value{
nothing
}
\description{
\code{duprateExpPlot} Duplication rate ~ total read count plot
}
\details{
This function makes a smooth scatter plot showing the per gene duplication
rate versus the total read count.
}
\examples{
# dm is a duplication matrix calculated by analyzeDuprates:
# R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
attach(dupRadar_examples)

# duprate plot
duprateExpPlot(DupMat=dm)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readcountExpBoxplot.R
\name{readcountExpBoxplot}
\alias{readcountExpBoxplot}
\title{Barplot of percentage of reads falling into expression bins}
\usage{
readcountExpBoxplot(DupMat, stepSize = 0.05, ...)
}
\arguments{
\item{DupMat}{The duplication matrix calculated by \code{analyzeDuprates}}

\item{stepSize}{The number of bars to be shown}

\item{...}{Other parameters sent to barplot()}
}
\value{
nothing Other parameters sent to barplot()
}
\description{
\code{readcountExpBoxplot} Barplot of percentage of reads falling into 
expression bins
}
\details{
This function makes a barplot of percentage of reads falling into expression
bins
}
\examples{
# dm is a duplication matrix calculated by analyzeDuprates:
# R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
attach(dupRadar_examples)


# barplot of percentage of reads falling into expression bins
readcountExpBoxplot(DupMat=dm)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getRpkBinReadCountFraction.R
\name{getRpkBinReadCountFraction}
\alias{getRpkBinReadCountFraction}
\title{Helper function used in \code{readcountExpressionBoxplot}}
\usage{
getRpkBinReadCountFraction(p, stepSize = stepSize, DupMat = DupMat)
}
\arguments{
\item{p}{The vector of bins}

\item{stepSize}{The window size}

\item{DupMat}{The duplication matrix calculated by \code{analyzeDuprates}}
}
\value{
The fraction of total reads in a vector of bins
}
\description{
\code{readcountExpressionBoxplot} Calculates the fraction of total reads in
  a vector of bins
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getBinRpkMean.R
\name{getBinRpkMean}
\alias{getBinRpkMean}
\title{Helper function used in \code{duprateExpBoxplot}}
\usage{
getBinRpkMean(p, stepSize, DupMat)
}
\arguments{
\item{p}{The vector of bins}

\item{stepSize}{The window size}

\item{DupMat}{The duplication matrix calculated by \code{analyzeDuprates}}
}
\value{
The averaged RPK per bin
}
\description{
\code{getBinRpkMean} get mean duplication rate per bin
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dupRadar-package.R
\docType{package}
\name{dupRadar}
\alias{dupRadar-package}
\alias{dupRadar}
\title{dupRadar.}
\description{
Duplication rate quality control for RNA-Seq datasets.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://www.bioconductor.org/packages/dupRadar}
  \item \url{https://ssayols.github.io/dupRadar/index.html}
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/markDuplicates.R
\name{picardMarkDuplicates}
\alias{picardMarkDuplicates}
\title{Mark duplicates using Picard tools}
\usage{
picardMarkDuplicates(bam, out, path, verbose, threads = 1, maxmem = "4g")
}
\arguments{
\item{bam}{The bam file to mark duplicates from}

\item{out}{Regular expression describing the transformation on the original
filename to get the output filename. By default, a "_duprm" suffix is
added before the bam extension}

\item{path}{Path to the duplicate marker binaries}

\item{verbose}{Redirect all the program output to the R console}

\item{threads}{Number of threads to use}

\item{maxmem}{Max memory assigned to the jvm}
}
\value{
The return code of the system call
}
\description{
\code{picardMarkDuplicates} Mark duplicated reads from a BAM file by calling
  picard tools
}
\details{
This function is supposed to be called through the \code{markDuplicates}
  wrapper
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/duprateExpBoxplot.R
\name{duprateExpBoxplot}
\alias{duprateExpBoxplot}
\title{Duplication rate ~ total reads per kilobase (RPK) boxplot}
\usage{
duprateExpBoxplot(DupMat, stepSize = 0.05, ...)
}
\arguments{
\item{DupMat}{The duplication matrix calculated by \code{analyzeDuprates}}

\item{stepSize}{Expression bin seze for the boxplot}

\item{...}{Other params sent to boxplot}
}
\value{
nothing
}
\description{
\code{duprateExpBoxplot} Duplication rate ~ total reads per kilobase (RPK) boxplot
}
\details{
This function makes a boxplot showing the distribution of per gene duplication rate versus
the reads per kilobase (RPK) inside gene expression bins.
}
\examples{
# dm is a duplication matrix calculated by analyzeDuprates:
# R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
attach(dupRadar_examples)

# duprate boxplot
duprateExpBoxplot(DupMat=dm)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getDupMatBin.R
\name{getDupMatBin}
\alias{getDupMatBin}
\title{Helper function used in \code{getBinDuplication} and
  \code{getBinRpkMean}}
\usage{
getDupMatBin(p, stepSize = 0.05, value = "allCounts", DupMat)
}
\arguments{
\item{p}{The vector of bins}

\item{stepSize}{The window size}

\item{value}{The column to be subset}

\item{DupMat}{The duplication matrix calculated by \code{analyzeDuprates}}
}
\value{
The subseted matrix
}
\description{
\code{getDupMatBin} get a subset of the matrix for values in a specific bin
defined by the upper bound p and stepSize
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getDupMatStats.R
\name{getDupMatStats}
\alias{getDupMatStats}
\title{Report duplication stats on regions}
\usage{
getDupMatStats(DupMat)
}
\arguments{
\item{DupMat}{The duplication matrix calculated by \code{analyzeDuprates}}
}
\value{
A data.frame containing the stats about the number of genes covered
  (1+ tags) and the number of genes containing duplicates (1+)
}
\description{
\code{getDupMatStats} Report duplication stats based on the data calculated
  in the duplication matrix
}
\examples{
# dm is a duplication matrix calculated by analyzeDuprates:
# R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
attach(dupRadar_examples)

# call the plot and identify genes
getDupMatStats(DupMat=dm)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dupRadar-package.R
\docType{data}
\name{dm}
\alias{dm}
\title{Duplication matrix of a good RNASeq experiment}
\format{
A data frame with 23228 rows and 14 variables
}
\usage{
data(dupRadar_examples)
}
\description{
A dataset containing the duplication matrix of a good RNASeq experiment, in
terms of duplicates. Comes from the GM12878 SR1x75 replicate 2 from Caltech
(UCSC's table Browser name: wgEncodeCaltechRnaSeqGm12878R1x75dAlignsRep2V2)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dupRadar-package.R
\docType{data}
\name{dupRadar_examples}
\alias{dupRadar_examples}
\title{Example data containing precomputed matrices for two RNASeq experiments}
\format{
A list with two example duplication matrices
}
\usage{
data(dupRadar_examples)
}
\description{
Precomputed duplication matrices for two RNASeq experiments used as examples
of a good and a failed (in terms of high redundancy of reads) experiments. 
The experiments come from the ENCODE project, as a source of a broad variety
of protocols, library types and sequencing facilities.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/duprateExpIdentify.R
\name{duprateExpIdentify}
\alias{duprateExpIdentify}
\title{Identify genes plotted by \code{duprateExpPlot}}
\usage{
duprateExpIdentify(DupMat, idCol = "ID")
}
\arguments{
\item{DupMat}{The duplication matrix calculated by \code{analyzeDuprates}}

\item{idCol}{The column from the duplication matrix containing the labels}
}
\value{
The identified points. \code{x} and \code{y} values match the ones 
 from \code{duprateExpPlot}
}
\description{
\code{duprateExpIdentify} Identify genes plotted by \code{duprateExpPlot}
}
\details{
This function makes a barplot showing the cumulative read counts fraction
from the duplication matrix calculated by \code{analyzeDuprates}.
}
\examples{
# dm is a duplication matrix calculated by analyzeDuprates:
# R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
attach(dupRadar_examples)

# call the plot and identify genes
duprateExpPlot(DupMat=dm)
duprateExpIdentify(DupMat=dm)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getRpkCumulativeReadCountFraction.R
\name{getRpkCumulativeReadCountFraction}
\alias{getRpkCumulativeReadCountFraction}
\title{Helper function used in \code{readcountExpressionBoxplot}}
\usage{
getRpkCumulativeReadCountFraction(p, DupMat = DupMat)
}
\arguments{
\item{p}{The vector of bins}

\item{DupMat}{The duplication matrix calculated by \code{analyzeDuprates}}
}
\value{
The cumulative read count fraction
}
\description{
\code{getRpkCumulativeReadCountFraction} get the cumulative read count
  fraction
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cumulativeDuprateBarplot.R
\name{cumulativeDuprateBarplot}
\alias{cumulativeDuprateBarplot}
\title{Barplot showing the cumulative read counts fraction}
\usage{
cumulativeDuprateBarplot(DupMat, stepSize = 0.05, ...)
}
\arguments{
\item{DupMat}{The duplication matrix calculated by \code{analyzeDuprates}}

\item{stepSize}{The size of the windows used for plotting}

\item{...}{Other params sent to barplot}
}
\value{
nothing
}
\description{
\code{cumulativeDuprateBarplot} Barplot showing the cumulative read counts
  fraction
}
\details{
This function makes a barplot showing the cumulative read counts fraction
from the duplication matrix calculated by \code{analyzeDuprates}.
}
\examples{
# dm is a duplication matrix calculated by analyzeDuprates:
# R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
attach(dupRadar_examples)

# call the plot
cumulativeDuprateBarplot(DupMat=dm)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getBinDuplication.R
\name{getBinDuplication}
\alias{getBinDuplication}
\title{Helper function used in \code{duprateExpBoxplot}}
\usage{
getBinDuplication(p, stepSize, DupMat)
}
\arguments{
\item{p}{The vector of bins}

\item{stepSize}{The window size}

\item{DupMat}{The duplication matrix calculated by \code{analyzeDuprates}}
}
\value{
The duplication rate per bin
}
\description{
\code{getBinDuplication} get duplication rate for a subset of the
duplication matrix
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/markDuplicates.R
\name{markDuplicates}
\alias{markDuplicates}
\title{Program dispatchers to mark duplicated reads from a BAM file}
\usage{
markDuplicates(
  dupremover = c("bamutil", "picard"),
  bam = NULL,
  out = gsub("\\\\.bam$", "_duprm.bam", bam),
  rminput = TRUE,
  path = ".",
  verbose = TRUE,
  ...
)
}
\arguments{
\item{dupremover}{The tool to be called. Currently, "picard" and "bamutils"
are supported}

\item{bam}{The bam file to mark duplicates from}

\item{out}{Regular expression describing the transformation on the original
filename to get the output filename. By default, a "_duprm" suffix is 
added before the bam extension}

\item{rminput}{Whether to keep the original, non duplicate-marked, bam file}

\item{path}{Path to the duplicate marker binaries}

\item{verbose}{Redirect all the program output to the R console}

\item{...}{Other parameters sent to the caller function}
}
\value{
The output filename
}
\description{
\code{markDuplicates} Mark duplicated reads from a BAM file by calling
  widely used tools.
}
\details{
This function works as a wrapper for several tools widely adopted tr mark
duplicated reads in a BAM file. Currently, it supports PICARD and BamUtils.
}
\examples{
\dontrun{
bam <- system.file("extdata","sample1Aligned.out.bam",package="dupRadar")
gtf <- "genes.gtf"
stranded <- 2    # '0' (unstranded), '1' (stranded) and '2' (reverse)
paired   <- FALSE
threads  <- 4

# call the duplicate marker and analyze the reads
bamDuprm <- markDuplicates(dupremover="bamutil",bam,
                           path="/opt/bamUtil-master/bin",rminput=FALSE)
dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/duprateExpDensPlot.R
\name{duprateExpDensPlot}
\alias{duprateExpDensPlot}
\title{Duplication rate ~ total read count plot}
\usage{
duprateExpDensPlot(
  DupMat,
  pal = c("cyan", "blue", "green", "yellow", "red"),
  tNoAlternative = TRUE,
  tRPKM = TRUE,
  tRPKMval = 0.5,
  tFit = TRUE,
  addLegend = TRUE,
  ...
)
}
\arguments{
\item{DupMat}{The duplication matrix calculated by \code{analyzeDuprates}}

\item{pal}{The color palette to use to display the density}

\item{tNoAlternative}{Display threshold of 1000 reads per kilobase}

\item{tRPKM}{Display threshold at a given RPKM level}

\item{tRPKMval}{The given RPKM level}

\item{tFit}{Whether to fit the model}

\item{addLegend}{Whether to add a legend to the plot}

\item{...}{Other parameters sent to plot()}
}
\value{
nothing
}
\description{
\code{duprateExpDensPlot} Duplication rate ~ total read count plot
}
\details{
This function makes a scatter plot showing the per gene duplication rate
versus the total read count.
}
\examples{
# dm is a duplication matrix calculated by analyzeDuprates:
# R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
attach(dupRadar_examples)

# duprate plot
duprateExpDensPlot(DupMat=dm)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getDynamicRange.R
\name{getDynamicRange}
\alias{getDynamicRange}
\title{Dynamic range}
\usage{
getDynamicRange(dm)
}
\arguments{
\item{dm}{The duplication matrix calculated by \code{analyzeDuprates}}
}
\value{
A list with 2 elements, containing the dynamic range counting all
reads and the dynamic range after removing duplicates.
}
\description{
\code{getDynamicRange} Calculate the dynamic range of the RNAseq experiment
}
\details{
This function calculates the dynamic range of the RNAseq eperiment
}
\examples{
# dm is a duplication matrix calculated by analyzeDuprates:
# R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
attach(dupRadar_examples)

# calculate the dynamic range
getDynamicRange(dm)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/duprateExpFit.R
\name{duprateExpFit}
\alias{duprateExpFit}
\title{Duplication rate ~ total read count fit model}
\usage{
duprateExpFit(DupMat)
}
\arguments{
\item{DupMat}{The duplication matrix calculated by \code{analyzeDuprates}}
}
\value{
The GLM and the coefficients of the fitted logit function
}
\description{
\code{duprateExpDensPlot} Duplication rate ~ total read count fit model
}
\details{
Fit a Generalized Linear Model using a logit function between thegene 
duplication rate and the total read count.
}
\examples{
# dm is a duplication matrix calculated by analyzeDuprates:
# R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
attach(dupRadar_examples)

# duprate plot
duprateExpFit(DupMat=dm)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyzeDuprates.R
\name{analyzeDuprates}
\alias{analyzeDuprates}
\title{Read in a BAM file and count the tags falling on the features described
in the GTF file}
\usage{
analyzeDuprates(
  bam,
  gtf,
  stranded = 0,
  paired = FALSE,
  threads = 1,
  verbose = FALSE,
  tmpDir = ".",
  ...
)
}
\arguments{
\item{bam}{The bam file containing the duplicate-marked reads}

\item{gtf}{The gtf file describing the features}

\item{stranded}{Whether the reads are strand specific}

\item{paired}{Paired end experiment?}

\item{threads}{The number of threads to be used for counting}

\item{verbose}{Whether to output Rsubread messages into the console}

\item{tmpDir}{Directory for temporary files created by featureCounts (default: ".")}

\item{...}{Other params sent to featureCounts}
}
\value{
A data.frame with counts on features, with and without taking into
  account multimappers/duplicated reads
}
\description{
\code{analyzeDuprates} returns a data.frame with tag counts
}
\details{
This function makes use of the Rsubread package to count tags on the GTF
features in different scenarios. The scenarios are the 4 possible
combinations of allowing multimappers (yes/no) and duplicate reads (yes/no).
}
\examples{
bam <- system.file("extdata",
    "wgEncodeCaltechRnaSeqGm12878R1x75dAlignsRep2V2_duprm.bam",
    package = "dupRadar"
)
gtf <- system.file("extdata", "genes.gtf", package = "dupRadar")
stranded <- 2 # '0' (unstranded), '1' (stranded) and '2' (reverse)
paired <- FALSE
threads <- 4

# call the duplicate marker and analyze the reads
dm <- analyzeDuprates(bam, gtf, stranded, paired, threads)

# use a different directory for temporary files (e.g., for FUSE filesystem issues)
dm <- analyzeDuprates(bam, gtf, stranded, paired, threads, tmpDir = "/tmp")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dupRadar-package.R
\docType{data}
\name{dm.bad}
\alias{dm.bad}
\title{Duplication matrix of a failed RNASeq experiment}
\format{
A data frame with 23228 rows and 14 variables
}
\usage{
data(dupRadar_examples)
}
\description{
A dataset containing the duplication matrix of a failed RNASeq experiment,
containing unusual duplication rate. Comes from the HCT116 PE2x75 replicate 1
from Caltech (UCSC's table Browser name: 
wgEncodeCaltechRnaSeqHct116R2x75Il200AlignsRep1V2)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/expressionHist.R
\name{expressionHist}
\alias{expressionHist}
\title{Draw histogram with the expression values}
\usage{
expressionHist(DupMat, value = "RPK", ...)
}
\arguments{
\item{DupMat}{The duplication matrix calculated by \code{analyzeDuprates}}

\item{value}{The column from the duplication matrix containing the
expression values}

\item{...}{Other parameters sent to hist()}
}
\value{
nothing
}
\description{
\code{expressionHist} Draw histogram with the expression values
}
\details{
This function draws a histogram of the expression values from the
duplication matrix calculated by \code{analyzeDuprates}.
}
\examples{
# dm is a duplication matrix calculated by analyzeDuprates:
# R> dm <- analyzeDuprates(bamDuprm,gtf,stranded,paired,threads)
attach(dupRadar_examples)

# histogram of expression values for annotation
expressionHist(DupMat=dm)
}
